/***************************************************************************
                          gameobject.h  -  description
                             -------------------
    begin                : Sat Feb 9 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GAMEOBJECT_H
#define GAMEOBJECT_H
#include "global_types.h"

/**
  *@author funthing (Matthias Zisler)
  */
class Map_Sample;
class CL_Surface;
class Timer;

class Gameobject
{
public: 
	Gameobject(int _x, int _y, Map_Sample* _sample);
	virtual ~Gameobject()=0;

	bool delete_me();
	void set_delme();
	void set_bbomb();
	void set_pos(int sx, int sy);
	GameobjectType get_type();

	virtual void act()=0;
	virtual void show()=0;

	int get_x();
	int get_y();

	int map_x();
	int map_y();
	int map_x(int off);
	int map_y(int off);

  bool block_left();
  bool block_right();
  bool block_up();
  bool block_down();
  bool on_ladder();
  bool up_ladder();
  bool on_bar();

	void move(DirType dir, float speed);

protected:

	GameobjectType got;
	CL_Surface* sur;
	bool del_me;
	int x, y, spr;
	float speed;
	DirType dir;
	Map_Sample* sample;
	Timer* timer;
};


class Dummy : public Gameobject
{
public:
	Dummy(int _x, int _y, Map_Sample* _sample);
	~Dummy();

	void act(){}
	void show(){}
};
#endif
